$set noverify
$set term/noecho
$read/prompt="Give crypto key>" sys$command key
$set term/echo
$inquire nmfile "Container file>"
$oldprv=f$setprv("all,nobypass")
$str="zrhostcry5/key="""+key+""" zra0: " + nmfile
$set noon
$set def sys$login:
$del f0srv.junk.*
$! Pass the key through to f0srv.com which will delete it after
$! reading it, minimizing exposure.
$open/write xxx f0srv.junk
$! We write the password to a scratch file but the client process
$! will delete it once received so the window is small.
$write xxx str
$close xxx
$infil:==xx
$infil=f$environment("default") + "f0srv.com"
$set verify
$run/det/auth/input='infil'/out=nla0:crygo.log sys$system:loginout
$set nover
$!write sys$output "Waiting to allow server process startup"
$!wait 0:0:15
$!write sys$output "Mounting cryptodisk cd:"
$!mount/over=id zra0:
$!assign zra0: cd0:
$!assign zra0: cd:
$set proc/priv=('oldprv')
$!This procedure runs a cryptodisk. It assumes that the
$! default DCLtables contains the zrHOSTcry5 verb and that
$! a user's crypto-disk is named zrcry.dsk in his sys$login
$! directory. (It doesn't have to be contiguous!) It then
$! spawns a subprocess to run the cryptodisk. 
$!  It is necessary to have the zrHOSTcry5 verb in the system
$! DCLtables since a command known via SET COMMAND locally
$! is not known to a spawned subprocess. While one could
$! write a command file that did the SET COMMAND and then
$! ran the zrHOSTcry4 program, care is needed to ensure
$! that the key string isn't left in a file on disk.
$! This method avoids such a hole. Perhaps one could pass
$! the keystring as a parameter as an alternative. Having
$! the cryptodisk as a privately mounted disk controlled
$! by a subprocess ensures that the disk is unavailable to
$! VMS if the main process is deleted for any reason (e.g.,
$! logs out). This is harmless to VMS; the zr: unit can
$! be reused, but it guarantees the disk will NOT be readable
$! in the clear after use is supposedly over. (Be careful not
$! to do something stupid like try to MSCP serve the disk
$! to a cluster when a subprocess is used for the host!)
$!   This procedure also assumes zrDRV is loaded and that
$! this user will use zra0: for the cryptodisk (which he
$! will later use as CD:). The idea is that the system manager
$! can allocate zr units for this and not have to rely on
$! user memory. OTher methods are of course possible.
$!  Glenn Everhart 3/1990
